/**
 * @file    Stepper_Demo.cpp
 *
 * @author  David Zemon
 *
 * @copyright
 * The MIT License (MIT)<br>
 * <br>Copyright (c) 2013 David Zemon<br>
 * <br>Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:<br>
 * <br>The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.<br>
 * <br>THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

// Includes
#include <PropWare/PropWare.h>
#include <PropWare/motor/stepper.h>

/**
 * @example     Stepper_Demo.cpp
 *
 * Move a stepper motor forward and backward at different speeds.
 *
 * @include PropWare_Stepper/CMakeLists.txt
 */
int main () {
    PropWare::Stepper stepper(PropWare::Port::P1, PropWare::Port::P2, PropWare::Port::P3, PropWare::Port::P4);

    stepper.step_forward(10); // Step forward 10 steps
    stepper.step_reverse(15); // Step back 15 steps
    stepper.step_forward(5, PropWare::Stepper::DEFAULT_DELAY / 2); // Step forward 5 steps, but do it twice as fast

    return 0;
}
